<template>
  <div v-bind:id="divId">
    <!-- Plotly chart will be drawn inside this DIV -->
  </div>
</template>

<script>
import { statMixin } from "./stat-mixin";


export default {
  mixins: [statMixin],
  computed:{
    selectedService:function () {
      return this.globalStore.selectedService
    },
  },
  methods: {
    createPlotly(title) {
      this.layout = {
        showlegend: false,
        title: title,
        barmode: 'stack',
        autosize: true
      };

      this.$Plotly.newPlot(this.divId, this.traceList, this.layout);
    },
    createColoredTraces() {
      this.createAllTraces(this.compParam.x_column, this.compParam.y_column);  
      this.setColors2Traces();         
      let title = this.compParam.plotly_title + " dal " + this.fromDate + " al " + this.toDate;
      this.createPlotly(title);       
    }
  },
  created() { 
    this.storePerService= this.colorStoreFactory(this.globalStore.selectedService)();
    this.getData(this.fromDate, this.toDate).then(()=>{
      console.log("------data in  other components received -----");    
      this.createColoredTraces();
    });
    this.$emitter.on("dateschanged", (dates) => {
      console.log("----dateschanged in :", this.divId,"---dates=",dates);
      this.resultDict = {};
      this.traceList = [];
      this.getData(dates[0], dates[1]).then(() => {
        this.fromDate = dates[0];
        this.toDate = dates[1];
        this.createAllTraces(this.compParam.x_column, this.compParam.y_column);
        this.setColors2Traces();   
        this.modify_visibility(); 
        this.layout.title = this.compParam.plotly_title + " dal " + this.fromDate + " al " + this.toDate;
        return this.$Plotly.react(this.divId,this.traceList,this.layout,{responsive: true});
      })
    });  
    this.$emitter.on("colorsdefined", () => {  
      this.createColoredTraces();
    }); 
  },
  watch:{
    selectedService:function(oldService, newService) {
      console.log("----just before resize ----" + oldService + "," + newService);
      this.modify_visibility();
      // this.$Plotly.Plots.resize(this.divId);
    }
  }
};
</script>
